/*
 * Saltine Cracker Conversion Routines
 * Copyright (C) 1999 aempirei
 * Produced by The Ambient Empire
 */

#include <stdlib.h>
#include "md4.h"

long *ntatob(char *);
long *c3atob(char *);
long *nthash(char *);
unsigned int h2i(char);
int putunicode(unsigned char *, char *);

static char c2b[256] = {
   -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
   -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1, 0, 1,
    2, 3, 4, 5, 6, 7, 8, 9,10,11,-1,-1,-1,-1,-1,-1,-1,12,13,14,15,16,17,18,
   19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,-1,-1,-1,-1,-1,
   -1,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,
   61,62,63,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
   -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
   -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
   -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
   -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
   -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
};

long *c3atob(char field[]) {
   static long l[2];

   int i;
   
   char n[12];
   char *p;
   char t;

   if(strlen(field) != 11) return NULL;
      
   for(i = 0; i < 11; i++) {
      if(c2b[field[i]] < 0) return NULL;
      n[i] = c2b[field[i]];
   }
   p = (char *)l;
   
   l[0]  = n[ 0] << 26;
   l[0] |= n[ 1] << 20;
   l[0] |= n[ 2] << 14;
   l[0] |= n[ 3] <<  8;
   l[0] |= n[ 4] <<  2;
   l[0] |= n[ 5] >>  4;

   l[1]  = n[ 5] << 28;
   l[1] |= n[ 6] << 22;
   l[1] |= n[ 7] << 16;
   l[1] |= n[ 8] << 10;
   l[1] |= n[ 9] <<  4;
   l[1] |= n[10] >>  2;

   t = p[0]; p[0] = p[3]; p[3] = t;
   t = p[1]; p[1] = p[2]; p[2] = t; 
   t = p[4]; p[4] = p[7]; p[7] = t;
   t = p[5]; p[5] = p[6]; p[6] = t; 
   
   return(l);
}

unsigned int h2i(char c) {
   if(('0' <= c) && (c <= '9')) return(c - '0');
   if(('A' <= c) && (c <= 'F')) return(c - 'A' + 10);
   if(('a' <= c) && (c <= 'f')) return(c - 'a' + 10);
   return(-1);
}

long *ntatob(char *hexstring) {
   static unsigned char *str;
   
   unsigned char c;
   int value[2];
   int i;

   str = (unsigned char *)malloc(17);
   for (i = 0; i < 31; i += 2) {
      if((value[0] = h2i(hexstring[i    ])) < 0) return NULL;
      if((value[1] = h2i(hexstring[i + 1])) < 0) return NULL;
      c = ((unsigned char)value[0] << 4) | (unsigned char)value[1];

      str[i >> 1] = c;
   }
   return((long *)str);
}

int putunicode(unsigned char *dst, char *src) {
   int ret = 0;
   while(*src) {
      dst[ret++] = src[0];
      dst[ret++] = 0;
      src++;
   }
   dst[ret++] = 0;
   dst[ret++] = 0;
   return(ret - 2);
}

long *nthash(char *passwd) {
   unsigned char hold[256];
   int uni_len;
   static MDstruct MD;
   int i = 0;

   uni_len = putunicode(hold, passwd);

   MDbegin(&MD);

   for(i = 0; i + 64 <= uni_len; i += 64)
      MDupdate(&MD, hold + (i >> 1), 512);

   MDupdate(&MD, hold + (i >> 1), (uni_len - i) << 3);

   return((long *)MD.buffer);
}
